//TODO:
//VACUUM
//PRAGMA INTEGRITY_CHECK
//prevent_intrusion - remove scripts&html at start

if (!DEBUG) {
	var DEBUG = false;
	var USE_UPDATES = false;
} else {
	var DEV = new DEVTOOLS();
	DEV.shortcuts();
}

var translation = {
	'sl-SI': {
		'time_not_matching': 'Čas računalnika se ne ujema s časom strežnika!',
		'current_time': 'Trenutni čas je',
		'fix_time': 'Popravite ga v nastavitvah računalnika.',
		'close': 'ZAPRI PROGRAM',
		'installing': 'Nameščanje nove verzije...'
	}
};

var SYS = {
	main_version: 1,
	micro_version: '',
	json_version: '',
	server_url: 'https://connector.eblagajna.com/pos/',
	key: '36b4c223d7b743aee68e2376dfe34a23',
	time_diff_max: 30*60*1000,
	update_interval: 60*60*1000,
	sys_updated: false,
	updated_exe_path: null,
	update_notification_shown: false,
	updater: null,
	server_online: false,
	db_connected: false,
	modules_loaded: false,
	locale: 'sl-SI', // TODO: hardcoded, read from system, ...

	datapath: '',
	platform: '',
	os: '',
	handheld: window.matchMedia("only screen and (max-width: 760px)").matches,
	db: {},
	modules: {},
	tpl: {},
	i18n: {},
	sql: {},
	print: {},

	gui: null,
	win: null,

	init: function () {
		SYS.loader.init();

		if (DEBUG) SYS.server_url = SERVER_url;

		var utils = new SYS.utils();
		SYS.datapath = utils.datapath();
		SYS.platform = utils.platform;
		if (SYS.platform === 'webkit') {
			SYS.gui = require('nw.gui');
			SYS.win = SYS.gui.Window.get();
			// if (!DEBUG) utils.prevent_intrusion();
			var pkg = require('./package.json');
			SYS.updater = new (require('./updater.js'))(pkg);
			SYS.json_version = pkg.version;

			var os = require('os');
			SYS.os = os.platform();

			if ((SYS.gui.App.argv.length === 3 && SYS.gui.App.argv[0] === 'install')) {
				// install app if run from temporary folder
				console.info('EXE: Copy started');
				SYS.updating = true;
				SYS.updater.install(SYS.gui.App.argv[1], function (err) {
					if (err) {
						console.error(err)
					} else {
						console.info('EXE: Copy done');
						SYS.updater.run(SYS.gui.App.argv[2], []);
						SYS.gui.App.quit();
					}
				});
			} else {
				// restart app if run from temporary folder if temp folder with nw.exe exists
				try {
					var path = SYS.updater.options.temporaryDirectory + '/eBlagajna/';
					if ((fs.lstatSync(path + 'nw.exe')).isFile()) {
						var new_manifest = require(path + 'package.json');
						if (new_manifest.version !== SYS.json_version) {
							SYS.updating = true;
							SYS.run_from_temp(path + 'nw.exe');
						}
					}
				} catch (e) {
				}
			}

		} else {
			if (SYS.handheld) {
				screen.lockOrientation('portrait');
			} else {
				screen.lockOrientation('landscape');
			}
			document.body.style.height = document.documentElement.clientHeight + 'px';
		}

		if (SYS.updating) {
			document.getElementById('LOADER_text').innerHTML = translation[SYS.locale]['installing'];
			return;
		}

		SYS.db = new SYS.db_connector();
		SYS.db_connect();
		SYS.db.select("SELECT name FROM sqlite_master WHERE type = 'table' AND name = 'pos_micro_updates';", function (data) {

			if (data.length == 1) {
				SYS.db.select("SELECT keyword, version, type FROM pos_micro_updates;", function (data) {
					var micro_version = {};
					for (var i = 0, len = data.length; i < len; ++i) {
						SYS.modules[data[i].keyword] = data[i].version;
						micro_version[data[i].keyword] = {
							v: data[i].version,
							t: data[i].type
						};
					}
					SYS.micro_version = JSON.stringify(micro_version);
					SYS.check_for_updates(SYS.update_modules);
				});

			} else {
				SYS.db.insert("CREATE TABLE pos_micro_updates (keyword TEXT PRIMARY KEY, type TEXT, version INTEGER, data TEXT);", function () {
					console.info('SYS: SYS db created');
					SYS.check_for_updates(SYS.update_modules);
				});
			}
		});
	},

	// restart if updates
	restart: function () {
		if (SYS.platform === 'webkit') {
			if (SYS.sys_updated) {
				if (SYS.updated_exe_path) {
					SYS.run_from_temp(SYS.updated_exe_path);
				} else {
					SYS.win.reloadDev();
				}
			}
		} else if (SYS.platform === 'cordova') {
			document.location.href = 'index.html?v=' + (new Date().getTime());
		}
	},


	run_from_temp: function (path) {
		// exe was updated, restart
		SYS.updater.runInstaller(path, ['install', SYS.updater.getAppPath(), SYS.updater.getAppExec()]);
		SYS.gui.App.quit();
	},


	db_connect: function () {
		if (!SYS.db_connected) {
			var sqlite_location = 'sqlcipher/sqlcipher.exe';
			if (SYS.os && SYS.os === 'linux') {
				sqlite_location = 'sqlcipher';
			}
			SYS.db.connect({
				database_name: 'SYS',
				pragma_key: '0086f933de681385abf8c79b8f81caa6',
				sqlite_location: sqlite_location
			});
			SYS.db_connected = true;
			console.info('SYS: SQLite connected');
		} else {
			console.info('SYS: SQLite already connected');
		}
	},


	db_close: function () {
		//TODO better solution
		if (SYS.platform === 'webkit') {
			SYS.db.close();
			console.info('SYS: SQLite disconnecting');
			SYS.db_connected = false;
		}
	},


	check_for_updates: function (callback) {
		var url = 'action=sys_update';
		// POS is running - this is run from daemon, use actual app_uid/app_key
		if (typeof APP_data !== 'undefined') {
			url += '&app_uid=' + APP_data.licence.app_uid + '&app_key=' + APP_data.licence.app_key;
			url += '&modules=' + SYS.micro_version;
		} else {
			url += '&key=' + SYS.key + '&modules=' + JSON.stringify(SYS.modules);
		}
		url += '&main_version=' + SYS.main_version;
		url += '&json_version=' + SYS.json_version;
		if (SYS.os) {
			url += '&os=' + SYS.os;
		}
		SYS.POST_data(SYS.server_url, url, SYS.update_modules_db);
	},


	update_notification: function () {
		// show notification if updated and on home screens
		if (SYS.sys_updated) {
			var home_notification = document.getElementById('HOME_update_notification');
			if (home_notification) {
				home_notification.style.display = 'block';
			}
		}
	},


	update_modules_db: function (data) {
		SYS.update_cnt = 0;
		var modules = data.modules ? data.modules : [];

		// SYS update
		if (modules.length > 0) {
			if (!SYS.db_connected) SYS.db_connect();
			var arr = [];
			if (data.all_modules) {
				arr.push({
					query: "DELETE FROM pos_micro_updates WHERE keyword NOT IN (" + data.all_modules + ");",
					params: []
				});
			}
			for (var i = 0, len = modules.length; i < len; ++i) {
				arr.push({
					query: "INSERT OR REPLACE INTO pos_micro_updates VALUES (?,?,?,?);",
					params: modules[i]
				});
				SYS.modules[modules[i][0]] = modules[i][2];
			}
			SYS.db.insert(arr, function (res) {
				SYS.sys_updated = true;
				console.info('SYS: Update complete');
				if (!SYS.modules_loaded) SYS.load_modules();
				else SYS.db_close();

				// show notification if done with all upgrades
				SYS.update_notification();
			}, true);

		} else {
			if (!SYS.modules_loaded) SYS.load_modules();
		}

		// EXE update
		if (!SYS.exe_updated && data.json_version && data.json_version !== SYS.json_version) {
			console.info('EXE: new version found - ' + data.json_version + ', downloading');

			if (SYS.platform === 'cordova') {

				console.log('TODO: run cordova update');

			} else if (SYS.platform === 'webkit') {

				var request = require('request');
				request(data.json_file, function (err, res, body) {
					var manifest = JSON.parse(body);

					SYS.updater.download(function(err, filename){
						console.info('EXE: new version download finished');
						if (err) {
							console.error('EXE: error download', err);
						}
						SYS.updater.unpack(filename, function (err, path) {
							if (err) {
								console.error('EXE: error unpack', err);
							} else {
								console.info('EXE: new version unpacked');
								SYS.updated_exe_path = path;
								SYS.sys_updated = true;
								// show notification if done with all upgrades
								SYS.update_notification();
							}
						}, manifest);
					}, manifest);
				});
			}
		}
	},


	load_modules: function () {
		if (!DEBUG || USE_UPDATES) {
			SYS.db.select("SELECT * FROM pos_micro_updates ORDER BY keyword;", function (data) {
				SYS.db_close();
				var init = '';
				var css = '';
				for (var i = 0, len = data.length; i < len; ++i) {

					try {

						switch (data[i].type){
							case 'css':
								css += SYS.from_b64(data[i].data);
								break;
							case 'js':
							case 'lib':
								eval.call(window, SYS.from_b64(data[i].data));
								break;
							case 'init':
								init = SYS.from_b64(data[i].data);
								break;
							case 'tpl':
								SYS.tpl[data[i].keyword] = SYS.from_b64(data[i].data);
								break;
							case 'i18n':
								SYS.i18n[data[i].keyword] = JSON.parse(SYS.from_b64(data[i].data));
								break;
							case 'sql':
								SYS.sql[data[i].keyword] = SYS.from_b64(data[i].data);
								break;
							case 'print':
								SYS.print[data[i].keyword] = SYS.from_b64(data[i].data);
								break;
						}

					} catch (e) {
						console.error(data[i].keyword);
						console.error(e.message);
					}

				}
				// load styles
				var style = document.createElement('style');
				style.innerHTML = css;
				document.head.appendChild(style);
				// eval scripts
				try {
					eval.call(window, init);
				} catch (e) {
					console.error(data[i].keyword);
					console.error(e.message);
				}
				SYS.modules_loaded = true;
				setTimeout(SYS.daemon, SYS.update_interval);
			});
		} else {
			DEV.load_modules();

			setTimeout(SYS.daemon, SYS.update_interval);
		}
	},


	daemon: function () {
		SYS.check_for_updates(SYS.update_modules);
		setTimeout(SYS.daemon, SYS.update_interval);
	},


	POST_data: function (url, data_string, callback, timeout) {
		var xhr = new XMLHttpRequest();
		xhr.timeout = 5 * 1000;
		if (typeof timeout !== 'undefined') {
			xhr.timeout = timeout;
		}
		xhr.onload = function () {
			if(xhr.readyState == 4) {
				if (xhr.status == 200) {
					SYS.server_online = true;
					if (SYS.time_sync(Date.parse(xhr.getResponseHeader('Date')))) callback(xhr.responseText ? JSON.parse(xhr.responseText) : '{}');
				}else{
					SYS.server_online = false;
					console.error('SYS: Unable to connect to server (' + url + '). Please check connectivity and try again, exit code ' + xhr.status + ' and readyState ' + xhr.readyState);
					callback({});
				}
			}
		};
		xhr.onerror = function () {
			SYS.server_online = false;
			console.error('SYS: Unable to connect to server (' + url + '). Please check connectivity and try again, exit code ' + xhr.status + ' and readyState ' + xhr.readyState);
			callback({});
		};
		xhr.ontimeout = xhr.onerror;
		xhr.open('POST', url, true);
		xhr.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
		xhr.send(data_string);
	},


	time_sync: function (server_time) {
		var time_diff = (Math.abs(new Date - server_time));
		if (time_diff < SYS.time_diff_max) {
			return true;
		} else {
			var dialog = document.createElement('div');
			dialog.id = 'TIME_DIALOG';
			dialog.style.position = 'fixed';
			dialog.style.zIndex = '99999';
			dialog.style.top = '0';
			dialog.style.left = '0';
			dialog.style.width = '100%';
			dialog.style.height = '100%';
			dialog.style.background  = 'rgba(255,255,255,0.8)';
			dialog.style.display = '-webkit-box';
			dialog.style.textAlign = 'center';
			dialog.style.webkitBoxPack = 'center';
			dialog.style.webkitBoxAlign = 'center';
			dialog.style.fontFamily = 'Roboto,Arial,sans-serif';
			dialog.style.fontWeight = 100;
			dialog.style.fontSize = '30px';
			dialog.appendChild(document.createTextNode(translation[SYS.locale]['time_not_matching']));
			dialog.appendChild(document.createElement('br'));
			var date = new Date(server_time);
			dialog.appendChild(document.createTextNode(translation[SYS.locale]['current_time'] + ": " + date.toLocaleString(SYS.locale)));
			dialog.appendChild(document.createElement('br'));
			dialog.appendChild(document.createTextNode(translation[SYS.locale]['fix_time']));
			dialog.appendChild(document.createElement('br'));
			var button = document.createElement('button');
			button.style.padding = '10px';
			button.style.backgroundColor = '#00adef';
			button.style.color = '#fff';
			button.style.height = '60px';
			button.style.width = '180px';
			button.style.fontFamily = 'Roboto,Arial,sans-serif';
			button.style.fontWeight = 300;
			button.style.fontSize = '12px';
			button.style.border = '0';
			button.style.outline = '0';
			button.style.marginTop = '30px';
			button.onmouseover = function () {
				this.style.backgroundColor = '#008abf';
			};
			button.onmouseout = function () {
				this.style.backgroundColor = '#00adef';
			};
			button.onclick = function () {
				if (SYS.platform === 'webkit') {
					SYS.win.close(1);
				} else {
					// TODO: close function for cordova
					console.log('TODO: close function for cordova');
				}
			};
			button.appendChild(document.createTextNode(translation[SYS.locale]['close']));
			dialog.appendChild(button);

			document.body.appendChild(dialog);
			document.getElementById('LOADER').remove();

			console.error('SYS: client time not synced');
			return false;
		}
	},


	loader: {
		init: function() {
			SYS.loader.show();
      document.getElementById('LOADER_text').appendChild(SYS.loader.dl_icon_svg());
		},
		hide: function() {
      if (!document.getElementById('LOADER')) return;
      var loader = document.getElementById('LOADER');
      while (loader.firstChild) loader.removeChild(loader.firstChild);
      loader.parentNode.removeChild(loader);
		},
		text: function(txt) {
			document.getElementById('LOADER_text').innerHTML = txt || '';
		},
		show: function() {
      if (document.getElementById('LOADER')) return;
      var loader = SYS.loader.loader_div();
      var svg = SYS.loader.loader_svg();
      svg.children[0].appendChild(SYS.loader.loader_animate_rotation())
      loader.appendChild(svg);
      document.body.appendChild(loader);
		},
		loader_div: function() {
			var loader = document.createElement('div');
      var loader_text = document.createElement('span');
      loader.id = 'LOADER';
      loader.style.position = 'fixed';
      loader.style.zIndex = '99999';
      loader.style.top = '0';
      loader.style.left = '0';
      loader.style.width = '100%';
      loader.style.height = '100%';
      loader.style.background  = 'rgba(255,255,255,0.8)';
      loader.style.display = '-webkit-box';
      loader.style.webkitBoxPack = 'center';
      loader.style.webkitBoxAlign = 'center';
      loader_text.id = 'LOADER_text';
      loader_text.style.position = 'absolute';
      loader_text.style.top = '50%';
      loader_text.style.left = '0';
      loader_text.style.right = '0';
      loader_text.style.marginTop = '70px';
      loader_text.style.textAlign = 'center';
      loader_text.style.fontSize = '30px';
      loader_text.style.fontWeight = '100';
      loader_text.style.color = '#000';
	  loader_text.style.fontFamily = 'Roboto,Arial,sans-serif';
	  loader_text.style.fontWeight = '100';
      loader.appendChild(loader_text);
      return loader;
    },
		loader_animate_rotation: function() {
			var svgNS = "http://www.w3.org/2000/svg";
			var animate = document.createElementNS(svgNS, "animateTransform");
			animate.setAttributeNS(null, 'attributeName', 'transform');
			animate.setAttributeNS(null, 'begin', '0s');
			animate.setAttributeNS(null, 'dur', '0.8s');
			animate.setAttributeNS(null, 'type', 'rotate');
			animate.setAttributeNS(null, 'from', '0 100 100');
			animate.setAttributeNS(null, 'to', '360 100 100');
			animate.setAttributeNS(null, 'repeatCount', 'indefinite');
      return document.createDocumentFragment().appendChild(animate);
    },
		loader_svg: function(size) {
			var svgNS = "http://www.w3.org/2000/svg";
			var svg = document.createElementNS(svgNS, "svg");
			var group = document.createElementNS(svgNS, "g");
			var path1 = document.createElementNS(svgNS, "path");
			var path2 = document.createElementNS(svgNS, "path");
			var path3 = document.createElementNS(svgNS, "path");
			svg.setAttributeNS(null, 'width', size || '100');
			svg.setAttributeNS(null, 'height', size || '100');
			svg.setAttributeNS(null, 'viewBox', '0 0 200 200');
			path1.setAttributeNS(null, 'd', 'M77.977,62.379c5.809-3.357,15.739-1.948,26.137,2.095c-2.011-9.931-5.198-19.531-10.138-28.408c-4.296-7.72-9.864-15.201-17.246-20.219c-5.039-3.425-10.941-5.418-17.074-4.863c-3.962,0.616-7.686,1.818-11.207,3.742l-0.091,0.054C41.83,18.607,37.4,25.384,34.188,32.047c-4.306,8.927-6.87,18.658-8.625,28.379c-2.404,13.31-3.273,26.91-3.021,40.424l0.018,1.09c0.294,11.488,1.401,22.98,3.529,34.277c1.788,9.489,4.288,18.92,8.077,27.821c0.066,0.157,0.134,0.313,0.202,0.469c-0.069-10.076,3.703-19.946,8.655-28.575c5.088-8.867,11.674-16.947,19.277-23.779c1.226-1.1,2.486-2.161,3.771-3.192c-0.863-9.492-0.45-19.273,1.742-28.569c0.897-3.806,2.116-7.594,3.983-11.044C73.273,66.618,75.242,63.958,77.977,62.379C83.786,59.022,69.786,67.111,77.977,62.379z');
			path2.setAttributeNS(null, 'd', 'M77.448,11.011c4.442,2.476,8.334,6.205,11.637,10.023c3.329,3.848,6.165,8.109,8.635,12.551c5.142,9.25,8.847,19.496,10.717,29.915c0.18,1.003,0.358,2.006,0.503,3.015c8.992,4.137,17.625,9.623,24.763,16.518c4.9,4.734,10.911,11.646,9.738,19.039c-0.576,3.625-2.554,6.933-4.751,9.804c-2.837,3.707-6.28,6.94-9.91,9.859l0,0c6.577,2.347,13.46,3.962,20.399,4.761c7.192,0.832,14.569,0.992,21.733-0.202c10.005-1.572,21.041-5.988,25.979-15.468c1.928-4.572,3.19-9.563,2.779-14.556c-0.251-3.038-1.055-6.009-2.172-8.837c-2.716-6.866-7.175-12.981-12.027-18.488c-12.456-14.137-28.297-25.376-44.572-34.69c-7.428-4.251-15.09-8.105-22.96-11.475C111.728,20.122,91.42,12.725,77.448,11.011z');
			path3.setAttributeNS(null, 'd', 'M78,138.105c-5.848-3.377-9.606-12.788-11.295-23.916c-21.287,18.224-35.56,48.106-23.419,65.233c2.524,3.156,5.441,5.821,8.88,7.946l0.083,0.045c4.46,2.689,9.852,3.602,14.98,3.799c4.724,0.181,9.463-0.26,14.119-1.038c10.24-1.714,20.197-5.03,29.757-9.023c19.688-8.225,38.323-19.521,54.76-33.124c8.236-6.816,16.031-14.327,22.492-22.872c-9.026,4.799-19.215,6.492-29.362,6.418c-10.767-0.077-21.578-2.027-31.707-5.675c-0.894-0.322-1.783-0.658-2.666-1.01C108.937,136.023,87.718,143.712,78,138.105C72.151,134.729,87.718,143.712,78,138.105z');
			group.appendChild(path1);
			group.appendChild(path2);
			group.appendChild(path3);
      svg.appendChild(group);
      return document.createDocumentFragment().appendChild(svg);
    },
		dl_icon_svg: function(size) {
			var svgNS = "http://www.w3.org/2000/svg";
			var svg = document.createElementNS(svgNS, "svg");
			var path = document.createElementNS(svgNS, "path");
			svg.setAttributeNS(null, 'width', size || '48');
			svg.setAttributeNS(null, 'height', size || '48');
			svg.setAttributeNS(null, 'viewBox', '0 0 48 48');
			path.setAttributeNS(null, 'd', 'M38.71,20.07C37.35,13.19,31.279,8,24,8c-5.78,0-10.79,3.28-13.3,8.07C4.69,16.72,0,21.81,0,28c0,6.63,5.37,12,12,12h26c5.52,0,10-4.48,10-10C48,24.721,43.891,20.44,38.71,20.07z M34,26L24,36L14,26h6v-8h8v8H34z');
			svg.appendChild(path);
      return document.createDocumentFragment().appendChild(svg);
    }
	},


	reload: function () {
		location.reload(true);
	},


	to_b64: function (str) {
		return btoa(unescape(encodeURIComponent(str)));
	},
	from_b64: function (str) {
		return decodeURIComponent(escape(atob(str)));
	},


	utils: function () {

		this.platform = typeof(device) === 'undefined' ? 'webkit' : 'cordova';

		this.datapath = function () {

			if (this.platform === 'cordova') {
				return cordova.file.applicationStorageDirectory;
			} else if (this.platform === 'webkit') {
				var gui = require('nw.gui');
				return gui.App.dataPath;
			}

		};

		// lists files in a directory, callback is optional, accepts error object and array of files
		this.listFiles = function (folder, callback) {

			if (this.platform === 'cordova') {

				window.resolveLocalFileSystemURL(folder, function (fs) {

					var directoryReader = fs.createReader();
					directoryReader.readEntries(function (entries) {

						var entries_flat = entries.map(function (entry) { return entry.name; });
						callback(null, entries_flat);

					}, function (error) {
						console.error(error);
					})
				}, function (error) {
					console.error(error);
				});

			} else if (this.platform === 'webkit') {
				var fs = require('fs');
				if (typeof(callback) === 'undefined') {
					// use synchronous method
					return fs.readdirSync(folder);
				} else {
					fs.readdir(folder, callback);
				}
			}

		};

		this.writeFile = function (filename, content, callback) {

			if (this.platform === 'cordova') {

				var split_filename = filename.split('/');
				var path = split_filename.slice(0, split_filename.length - 1).join('/');
				var filename = split_filename[split_filename.length - 1];

				window.resolveLocalFileSystemURL(path, function (fs) {

					fs.getFile(filename, {create: true}, function (fe) {
						fe.createWriter(function(writer) {

							writer.write(content);
							callback(null, content);

						}, function (error) {
							console.error(error);
						});
					});

				}, function (error) {
					console.error(error);
				});

			} else if (this.platform === 'webkit') {
				var fs = require('fs');
				if (typeof(callback) === 'undefined') {
					// use synchronous method
					return fs.writeFileSync(filename, content);
				} else {
					fs.writeFile(filename, content, callback);
				}

			}
		};

		this.readFile = function (filename, callback) {

			if (this.platform === 'cordova') {

				if (typeof(callback) === 'undefined') {
					// synchronous mode not supported on cordova
					console.error("Callback is required on cordova");
					return;
				}

				var split_filename = filename.split('/');
				var path = split_filename.slice(0, split_filename.length - 1).join('/');
				var filename = split_filename[split_filename.length - 1];

				window.resolveLocalFileSystemURL(path, function (fs) {

					fs.getFile(filename, {create: true}, function (fe) {
						fe.file(function (file) {
							var reader = new FileReader();

							reader.onloadend = function (e) {
								callback(null, e.target.result);
							};

							reader.readAsText(file);
						});
					});

				}, function (error) {
					console.error(error);
				});

			} else if (this.platform === 'webkit') {

				var fs = require('fs');
				if (typeof(callback) === 'undefined') {
					// use synchronous method
					return fs.readFileSync(filename).toString();
				} else {
					fs.readFile(filename, callback);
				}

			}

		};

		this.deleteFile = function (filename, callback) {

			if (this.platform === 'cordova') {

				var split_filename = filename.split('/');
				var path = split_filename.slice(0, split_filename.length - 1).join('/');
				var filename = split_filename[split_filename.length - 1];

				window.resolveLocalFileSystemURL(path, function (fs) {

					fs.getFile(filename, {create: true}, function (fe) {
						fe.remove(function (success) {
							callback(null, success);
						}, function (fail) {
							callback(fail, null);
						});
					});

				}, function (error) {
					console.error(error);
				});

			} else if (this.platform === 'webkit') {
				var fs = require('fs');
				if (typeof(callback) === 'undefined') {
					// use synchronous method
					return fs.unlinkSync(filename);
				} else {
					fs.unlink(filename, callback);
				}

			}

		};

		this.prevent_intrusion = function (callback) {

			if (this.platform === 'webkit') {
							SYS.win.on("devtools-opened", function() {
									SYS.win.close();
							});
					}

					callback;
		};

	},


	db_connector: function () {

		var dblite = null;
		this.db = null;
		this.query_queue = [];
		this.running_queries = false;

		var QueueObject = function (queries, callback) {
			this.queries = queries;
			this.callback = callback;
		};

		// options: database_name, pragma_key, sqlite_location
		this.connect = function (options) {

			if (this.db !== null) { return; }

			// set connect and db based on platform
			if (SYS.platform === 'cordova') {

				this.db = window.sqlitePlugin.openDatabase({
					name: options.database_name,
					key: options.pragma_key
				});

			} else if (SYS.platform === 'webkit') {

				dblite = require('dblite');
				dblite.bin = options.sqlite_location;
				// -header returns select results as objects instead of simple array
				this.db = dblite(SYS.datapath+'/'+options.database_name, '-header');
				// ugly hack: suppress dblite quit warning - there's a bug with exiting and android transactions
				this.db.on('error', function (err) {
					if (err.toString().indexOf('cannot start a transaction within a transaction') !== -1
						&& err.toString().indexOf('cannot commit - no transaction is active') !== -1) {
						return;
					}
					console.error(err.toString());
				});
				if (!DEBUG) this.db.query("PRAGMA key=?;", [options.pragma_key]);

			}

		};

		this._makeQueryObject = function (obj) {

			var params = [];
			var query = obj;
			if (typeof(obj) === 'object') {
				if (obj.hasOwnProperty('params')) {
					params = obj.params;
				}
				if (obj.hasOwnProperty('query')) {
					query = obj.query;
				}
			}
			if (typeof(query) !== "string") {
				throw new Error("Query has to be string.");
			}

			return {query: query, params: params};
		};


		// using queue to run queries in order and in transaction
		this._run_queries = function () {

			if (this.running_queries) {
				return;
			}

			this.running_queries = true;
			while (this.query_queue.length !== 0) {
				var current_query_obj = this.query_queue.shift();

				this.db.query('BEGIN TRANSACTION;');

				for (var i in current_query_obj.queries) {

					var q = current_query_obj.queries[i];
					var query_obj = this._makeQueryObject(q);
					// workaround for dblite - it crashes if params is empty array
					if (Array.isArray(query_obj.params) && query_obj.params.length === 0) {
						query_obj.params = null;
					}
					this.db.query(query_obj.query, query_obj.params, function (err, data) {
						var res = err ? err : data;
						current_query_obj.callback(res); // getting query is not supported by dblib/node - strange thread data sync
					});

				}

				this.db.query('COMMIT;');

			}
			this.running_queries = false;

		};

		// query can be either string (single query), object with query and params keys or array of such objects (for multiple queries)
		this.query = function (query, callback, use_transaction) {

			if (this.db === null) { return; }

			if (typeof(callback) === 'undefined') { callback = function (res) {}; }
			if (typeof(use_transaction) === 'undefined') { use_transaction = false; }

			var queries = [];
			if (!Array.isArray(query)) {
				queries = [query];
			} else {
				queries = query;
			}

			if (SYS.platform === 'cordova') {

				// scope workaround to make function available inside callback
				var makeQuery = this._makeQueryObject;

				var current = null;
				this.db.transaction(function (tx) {
					for (var i in queries) {

						var q = queries[i];

						var query_obj = makeQuery(q);
						current = query_obj;

						tx.executeSql(query_obj.query, query_obj.params, function (tx, res) {
							callback(res);
							return;
						});

					}
				}, function(e) {
					console.error("ERROR: " + e.message, e, current);
				});

			} else if (SYS.platform === 'webkit') {

				this.query_queue.push(new QueueObject(queries, callback));
				this._run_queries();

			}

		};

		// callback should accept data
		this.select = function (query, callback) {

			if (this.db === null) { return; }

			if (SYS.platform === 'cordova') {

				this.query(query, function (res) {
					var data = [];
					for (var i = 0; i < res.rows.length; i++) {
						data.push(res.rows.item(i));
					}
					callback(data);
					return;
				});
			} else if (SYS.platform === 'webkit') {

				this.query(query, callback);

			}

		};

		// query can be either string (single query), object with query and params keys or array of such objects (for multiple queries)
		this.insert = function (query, callback, use_transaction) {

			if (this.db === null) { return; }

			if (typeof(callback) === 'undefined') { callback = function (res) {}; }
			if (typeof(use_transaction) === 'undefined') { use_transaction = false; }

			var length = 0;
			if (!Array.isArray(query)) {
				length = 1;
			} else {
				length = query.length;
			}

			var count = 0;

			this.query(query, function (res) {
				if (res && res.hasOwnProperty('message')) {
					console.error(res.message);
				}
				count++;

				if (count === length) {
					callback();
					return;
				}
			}, use_transaction);

		};

		// max_size in MB, callback returns boolean, if vaccum was run
		this.optimize = function(max_size, callback) {

			if (this.db === null) { return; }

			if (typeof(callback) === 'undefined') { callback = function (res) {}; }
			if (typeof(max_size) === 'undefined') {
				throw new Error("max_size is not set");
			}

			if (SYS.platform === 'cordova') {

				this.db.executeSql('PRAGMA page_size;', function (tx, res) {
					console.log(tx, res);
				});

			} else if (SYS.platform === 'webkit') {

				var db = this.db;
				db.query('PRAGMA page_size;', function (err, data) {
					if (err) {
						console.error(err);
						return;
					}
					var page_size = data[0].page_size;
					db.query('PRAGMA freelist_count;', function (err, data) {
						if (err) {
							console.error(err);
							return;
						}
						var freelist_count = data[0].freelist_count;

						if (freelist_count * page_size > max_size * 1024 * 1024) {
							db.query('VACUUM;', function (err, data) {
								if (err) {
									console.error(err);
									return;
								}
								callback(true);
							});
						} else {
							callback(false);
						}

					});

				});

			}

		};

		this.close = function () {

			if (this.db === null) {
				return;
			}

			this.db.close();
			this.db = null;

		};

	}

};

if (!window.cordova) {
	SYS.init();
} else {
	document.addEventListener("deviceready", SYS.init, false);
}
